;*************************************************************
;
;
;Lisproutine zur Erstellung lageunabhngiger Gitterkreuze
;
;berarbeitete Version Stand 27okt93 V1.1
;
;Programmiert von Martin Ernst (Vermessungsbro Strackenbrock)
;
;
;zugehrige Datein:
;-rah.dcl           (Dialogbox)
;
;berarbeitet am 08.02.2005
;- bersetzung der Umlaute und des Buchstaben ""
;- Vorgabe der Werte "Y=" und "X=" wurden entfernt, so dass in der Dialogbox keine Vorgaben erscheinen
;
; P. Steinbeck VBP GmbH
;
;*************************************************************

;Fehlerfunktion********************
(defun *error* (st)
 (princ "Fehler: ")
 (princ st)
 (terpri)
)

(defun c:rast (/ ofalt setw1 setw2 setw3 osmode p1 p2 p3 p4 po pu zh mst symb
                 kgr andd to th  epb anr dx dy brw bhw wu tl kp pr pl xl
                 ymin ymax ew sp lapu lapo x1 x2 y1 y2 dxu dxo
                 tox toy w1 w2 swap bex bey bsw flagsp)


;Dialogfunktionen definieren********************************
(defun defaults()
 (setq x1  (car p1)
       y1  (cadr p1)
       x2  (car p2)
       y2  (cadr p2))
 (if x1 (set_tile "x_p1" (rtos x1 2)))
 (if y1 (set_tile "y_p1" (rtos y1 2)))
 (if x2 (set_tile "x_p2" (rtos x2 2)))
 (if y2 (set_tile "y_p2" (rtos y2 2)))
 (set_tile "dx" (rtos dx 2))
 (set_tile "dy" (rtos dy 2))
 (if (= symb 0) (set_tile "symb0" "1"))
 (if (= symb 1) (set_tile "symb1" "1"))          
 (if (= symb 2) (set_tile "symb2" "1"))          
 (if (= symb 3) (set_tile "symb3" "1"))          
 (set_tile "and" (rtos andd 2 0) )
 (if (= mst 0) (setq aw 0) (setq aw (* 1000 (/ th mst))))
 (set_tile "th" (rtos aw 2))      
 (if (= mst 0) (setq aw 0) (setq aw (* 1000 (/ kgr mst))))  
 (set_tile "kgr" (rtos aw 2))
 (if (= to 1) (set_tile "to" "1") (set_tile "to" "0"))      
 (if (= epb 1) (set_tile "epb" "1") (set_tile "epb" "0"))      
 (if (= anr 1) (set_tile "anr" "1") (set_tile "anr" "0"))      
 (set_tile "bhw" bhw)
 (set_tile "brw" brw)
 (set_tile "mst" (rtos mst 2))
 (set_tile "zh"  (rtos zh 2))
)
(defun do_mst()
 (setq mst (atof (get_tile "mst")))
 (if (not mst) (setq mst 0))
 (setq kgr (* 0.003 mst))
 (set_tile "kgr" "3")
 (setq th (* 0.0018 mst))
 (set_tile "th" "1.8")
 (setq dxo (* 0.1 mst)
       dx  dxo
       dy  dxo)
 (set_tile "dx" (rtos dxo 2))
 (set_tile "dy" (rtos dxo 2))
)
(defun do_zh()
 (setq zh (atof (get_tile "zh")))
 (if (not zh) (setq zh 0))
)
;(defun do_pickp1()
;)
(defun do_xp1()
 (setq x1 (atof (get_tile "x_p1")))
 (setq y1 (atof (get_tile "y_p1")))
 (if x1 (if y1 (setq p1 (list x1 y1 0))))
)
(defun do_yp1()
 (setq x1 (atof (get_tile "x_p1")))
 (setq y1 (atof (get_tile "y_p1")))
 (if x1 (if y1 (setq p1 (list x1 y1 0))))
)
;(defun do_pickp2()
;)
(defun do_xp2()
 (setq x2 (atof (get_tile "x_p2")))
 (setq y2 (atof (get_tile "y_p2")))
 (if x2 (if y2 (setq p2 (list x2 y2 0))))
)
(defun do_yp2()
 (setq x2 (atof (get_tile "x_p2")))
 (setq y2 (atof (get_tile "y_p2")))
 (if x2 (if y2 (setq p2 (list x2 y2 0))))
)
(defun do_dx()
 (setq dx (atof (get_tile "dx")))
 (if (not dx) (setq dx 0))
)
(defun do_dy()
 (setq dy (atof (get_tile "dy")))
 (if (not dy) (setq dx 0))
)
(defun do_symb0()
 (set_tile "symb0" "1")
 (setq symb 0)
)
(defun do_symb1()
 (set_tile "symb1" "1")
 (setq symb 1)
)
(defun do_symb2()
 (set_tile "symb2" "1")
 (setq symb 2)
)
(defun do_symb3()
 (set_tile "symb3" "1")
 (setq symb 3)
)
(defun do_and()
 (setq andd (atoi (get_tile "and")))
 (if (not andd) (setq andd 2))
)
(defun do_th()
 (setq th (atof (get_tile "th")))
 (if   th (setq th (* mst (/ th 1000))) 
  (setq th 0))
)
(defun do_kgr()
 (setq kgr (atof (get_tile "kgr")))
 (if kgr (setq kgr (* mst (/ kgr 1000))) (setq kgr 0))
)
(defun do_to()
 (if (= to 1) (setq to 0) (setq to 1))
)
(defun do_epb()
 (if (= epb 1) (setq epb 0) (setq epb 1))    
)
(defun do_anr()
 (if (= anr 1) (setq anr 0) (setq anr 1))   
)
(defun do_bhw()
 (setq bhw (get_tile "bhw"))
)
(defun do_brw()
 (setq brw (get_tile "brw"))
)

;(defun c:rast()
;Initialisierung
(setvar "cmdecho" 0)
(setq aklayer (getvar "clayer"))
(setq ofalt (getvar "osmode")
      setw1 (getvar "aunits")
      setw2 (getvar "angbase")
      setw3 (getvar "angdir")
      )
(setvar "aunits" 0)
(setvar "angbase" 0)
(setvar "angdir" 0)

(setvar "osmode" 0)
(command "layer" "n" "BEGRENZUNG" "")
(command "layer" "n" "ANRISS" "")
(command "layer" "n" "KOORDINATEN" "")
(command "layer" "n" "GITTERKREUZE" "")
(command "layer" "n" "ECKKOO" "")
;default-Werte zuweisen*****************************************
(setq p1 (list 0 0 0))
(setq p2 (list 0 0 0))
(setq zh 0)
(setq mst 0)
(setq symb 1)
(setq kgr 0)
(setq andd 2)
(setq to 1)
(setq th 0)
(setq epb 1)
(setq anr 1)
(setq dx 0
      dy 0)
;Bezeichnung Rechts-Hochwert
(setq brw "")
(setq bhw "")
(setq flagsp 1)
(if  (< (setq dcl_id (load_dialog "rah.dcl")) 0) (exit))

(while flagsp
(setq wn 5)
(while (< 2 wn)
 (if (not (new_dialog "rast" dcl_id)) (exit))
 (defaults)
 (action_tile "mst"      "(do_mst)")
 (action_tile "zh"       "(do_zh)")
 (action_tile "x_p1"     "(do_xp1)")  
 (action_tile "y_p1"     "(do_yp1)")  
 (action_tile "x_p2"     "(do_xp2)")  
 (action_tile "y_p2"     "(do_yp2)")  
 (action_tile "dx"       "(do_dx)")  
 (action_tile "dy"       "(do_dy)")  
 (action_tile "symb0"    "(do_symb0)")  
 (action_tile "symb1"    "(do_symb1)")  
 (action_tile "symb2"    "(do_symb2)")  
 (action_tile "symb3"    "(do_symb3)")  
 (action_tile "and"      "(do_and)")  
 (action_tile "th"       "(do_th)")  
 (action_tile "kgr"      "(do_kgr)")
 (action_tile "to"       "(do_to)")  
 (action_tile "epb"      "(do_epb)")  
 (action_tile "anr"      "(do_anr)")  
 (action_tile "pick_p1"  "(done_dialog 3)")
 (action_tile "pick_p2"  "(done_dialog 4)")    
 (action_tile "bhw"      "(do_bhw)")
 (action_tile "brw"      "(do_brw)")      

 (setq wn (start_dialog))

 (cond
   ((= wn 0) (quit))
   ((= wn 3)
    (initget 1)
    (setq p1 (getpoint "linker oberer Eckpunkt:"))
   )
   ((= wn 4)
    (initget 1)
    (setq p2 (getpoint "rechter oberer Eckpunkt:"))
   )
 )
)
;(unload_dialog dcl_id)    
(setq flagsp nil
      mst (abs mst)
      zh  (abs zh)
      dx  (abs dx)
      dy  (abs dy)
      th  (abs th)
      kgr (abs kgr))
(if (= mst 0) (progn
                (setq flagsp 1)
                (princ "\nMastab mu grer sein als 0")
               ))
(if (= zh  0) (progn
                (setq flagsp 1)
                (princ "\nZeichnungshhe mu grer als 0 sein")
              ))
(if (= dx 0) (progn
                (setq flagsp 1)
                (princ "\ndx mu grer als 0 sein")
              ))
(if (= dy 0) (progn
                (setq flagsp 1)
                (princ "\ndy mu grer als 0 sein")
              ))
(if (> dx (distance p1 p2)) (progn
                             (setq flagsp 1)
                             (princ "\ndRechtswert zu gro")
                            ))
(if (> dy zh) (progn
               (setq flagsp 1)
               (princ "\ndHochwert zu gro")
              ))
(if (= th 0) (progn
                (setq flagsp 1)
                (princ "\nDie Texthhe mu grer als 0 sein")
              ))
(if (= kgr 0) (progn
                 (setq flagsp 1)
                 (princ "\nDie Kreuzgre mu grer als 0 sein")
              ))
)
(unload_dialog dcl_id)
(setq kgr (/ kgr 2))

(setq w1 (- (angle p1 p2) (/ pi 2)))
(setq p3 (polar p2 w1 zh))
(setq p4 (polar p1 w1 zh))
;Textorientierung anpassen (tox toy)********
(setq w2 (* (/ (angle p1 p2) pi) 180))
(if (and (>= w2 0) (< w2 90)) (setq    tox 0
                                       toy 90
                                       swap 0))
(if (and (>= w2 180) (< w2 270)) (setq tox 180
                                       toy 270
                                       swap 0))
(if (and (>= w2 270) (< w2 360)) (setq tox 0
                                       toy 270
                                       swap 1))
(if (and (>= w2 90) (< w2 180)) (setq  tox 180
                                       toy 90
                                       swap 1))
;Zeichnen der Begrenzung
(command "layer" "se" "BEGRENZUNG" "")
(command "plinie" p1 p2 p3 p4 "s")
(setq fl 1
      kp p1)
(if (< (car p2) (car kp)) (setq kp p2
                                fl  2))
(if (< (car p3) (car kp)) (setq kp p3
                                fl  3))
(if (< (car p4) (car kp)) (setq kp p4
                                fl  4))
(if (= fl 1) (setq pl p1
                   po p2
                   pr p3
                   pu p4))
(if (= fl 2) (setq pl p2
                   po p3
                   pr p4
                   pu p1))
(if (= fl 3) (setq pl p3
                   po p4
                   pr p1
                   pu p2))
(if (= fl 4) (setq pl p4
                   po p1
                   pr p2
                   pu p3))
;Berechnung des Startpunktes********************************
(setq fl 1)
(setq xl (+ (* (fix (/ (car pl) dx)) dx) dx))    
(setq ymin (* (fix (/ (cadr pl) dy)) dy)
      ymax (+ ymin dy))
(while fl
 ;so bilden
 (if (< xl (car po))  (setq so (inters pl po (list xl 0 0) (list xl 1 0) nil))
                      (setq so (inters po pr (list xl 0 0) (list xl 1 0) nil)))
 ;su bilden
 (if (< xl (car pu)) (setq su (inters pl pu (list xl 0 0) (list xl 1 0) nil))
                     (setq su (inters pu pr (list xl 0 0) (list xl 1 0) nil)))
 (if (< ymax (cadr so)) (progn 
                         (setq fl nil)
                         (setq sp (list xl ymax 0))
                        )
                        (progn
                         (if (> ymin (cadr su))
                           (progn
                            (setq fl nil)
                            (setq sp (list xl ymin 0))
                           ))
                        ))
 (setq xl (+ xl dx))
)
;mgliche Korrektur****************
;Startpunkt wurde so berechnet, da er im Rahmen liegt
(setq flagsp 1)
(while flagsp
 (setq ew (getpoint sp "\nStartpunkt: "))
 (if ew (setq sp ew))
 ;ist er immer noch im Rahmen?
 (if (and (> (car sp) (car pl))
          (< (car sp) (car pr))
          (> (cadr sp) (cadr pu)) 
          (< (cadr sp) (cadr po))) (setq flagsp nil)
                                   (princ "\nStartpunkt liegt auerhalb."))
)
;Aufrastern x steigend*******************************************************
(setq xl (car sp))
(while (< xl (- (car pr) kgr))
 ;so bilden
 (if (< xl (car po)) (progn
                      (setq so (inters pl po (list xl 0 0) (list xl 1 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (cos (angle pl po))))))
                     (progn                     
                      (setq so (inters po pr (list xl 0 0) (list xl 1 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (cos (angle po pr)))))))
 ;su bilden
 (if (< xl (car pu)) (progn
                      (setq su (inters pl pu (list xl 0 0) (list xl 1 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (cos (angle pl pu))))))
                     (progn                     
                      (setq su (inters pu pr (list xl 0 0) (list xl 1 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (cos (angle pu pr)))))))
 ;durchgezogenes Gitter?
 (command "layer" "se" "GITTERKREUZE" "")
 (if (= symb 2) (command "plinie" su so ""))
 ;Anri?
 (if (= anr 1) 
  (progn
   (command "layer" "se" "ANRISS" "")
   (command "plinie" so (list (car so) (- (cadr so) lapo)) "")
   (command "plinie" su (list (car su) (+ (cadr su) lapu)) "")))
 ;Text antragen Y
 (command "layer" "se" "KOORDINATEN" "")         
 (setq te brw)
 (setq te (strcat te (rtos xl 2 andd)))
 (if (= to 1)
  (progn
  (if (= toy 90)
   (progn 
   (command "text" "p" "mr" (list (car su) (- (cadr su) lapu)) th 90 te)
   (command "text" "p" "ml" (list (car so) (+ (cadr so) lapo)) th 90 te)
   )
   (progn
   (command "text" "p" "ml" (list (car su) (- (cadr su) lapu)) th 270 te)
   (command "text" "p" "mr" (list (car so) (+ (cadr so) lapo)) th 270 te)
   ))
  )
;oder innen beschriften
  (progn
  (if (= toy 90)
   (progn 
   (command "text" "p" "ml" (list (car su) (+ (cadr su) (* 2 lapu))) th 90 te)
   (command "text" "p" "mr" (list (car so) (- (cadr so) (* 2 lapo))) th 90 te)
   )
   (progn
   (command "text" "p" "mr" (list (car su) (+ (cadr su) (* 2 lapu))) th 270 te)
   (command "text" "p" "ml" (list (car so) (- (cadr so) (* 2 lapo))) th 270 te)
   ))
  )
  )
 ;y steigend rastern
 (command "layer" "se" "GITTERKREUZE" "")
 (setq yl (cadr sp))
 (while (< yl (- (cadr so) kgr))
  (if (> yl (+ (cadr su) kgr))
   (progn
   (if (= symb 1) (kreuzi (list xl yl 0)))
   (if (= symb 3) (kreuzii (list xl yl 0)))   
   )
  )
   (setq yl (+ yl dy))
 )
 ;y fallend rastern
 (setq yl (- (cadr sp) dy))
 (while (> yl (+ (cadr su) kgr))
  (if (< yl (- (cadr so) kgr))
   (progn
   (if (= symb 1) (kreuzi (list xl yl 0)))   
   (if (= symb 3) (kreuzii (list xl yl 0)))     
   )
  ) 
   (setq yl (- yl dy))
 )
 (setq xl (+ xl dx))
)
;Aufrastern x fallend******************************************************
(setq xl (- (car sp) dx))
(while (> xl (+ (car pl) kgr))
 ;so bilden
 (if (< xl (car po)) (progn
                      (setq so (inters pl po (list xl 0 0) (list xl 1 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (cos (angle pl po))))))
                     (progn                     
                      (setq so (inters po pr (list xl 0 0) (list xl 1 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (cos (angle po pr)))))))
 ;su bilden
 (if (< xl (car pu)) (progn
                      (setq su (inters pl pu (list xl 0 0) (list xl 1 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (cos (angle pl pu))))))
                     (progn                     
                      (setq su (inters pu pr (list xl 0 0) (list xl 1 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (cos (angle pu pr)))))))
 
 ;durchgezogenes Gitter?
 (command "layer" "se" "GITTERKREUZE" "")
 (if (= symb 2) (command "plinie" su so ""))
 ;Anri?
 (if (= anr 1) 
  (progn
   (command "layer" "se" "ANRISS" "")
   (command "plinie" so (list (car so) (- (cadr so) lapo)) "")
   (command "plinie" su (list (car su) (+ (cadr su) lapu)) "")))
 ;Text antragen Y
 (command "layer" "se" "KOORDINATEN" "")
 (setq te brw)
 (setq te (strcat te (rtos xl 2 andd)))
 (if (= to 1)
  (progn
  (if (= toy 90)
  (progn
   (command "text" "p" "mr" (list (car su) (- (cadr su) lapu)) th 90 te)
   (command "text" "p" "ml" (list (car so) (+ (cadr so) lapo)) th 90 te)
  )
  (progn
   (command "text" "p" "ml" (list (car su) (- (cadr su) lapu)) th 270 te)
   (command "text" "p" "mr" (list (car so) (+ (cadr so) lapo)) th 270 te)
  ))
  )
;oder innen beschriften
  (progn
  (if (= toy 90)
  (progn
   (command "text" "p" "ml" (list (car su) (+ (cadr su) (* 2 lapu))) th 90 te)
   (command "text" "p" "mr" (list (car so) (- (cadr so) (* 2 lapo))) th 90 te)
  )
  (progn
   (command "text" "p" "mr" (list (car su) (+ (cadr su) (* 2 lapu))) th 270 te)
   (command "text" "p" "ml" (list (car so) (- (cadr so) (* 2 lapo))) th 270 te)
  ))
  )
  )
 ;y steigend rastern
 (command "layer" "se" "GITTERKREUZE" "")
 (setq yl (cadr sp))
 (while (< yl (- (cadr so) kgr))
  (if (> yl (+ (cadr su) kgr))
   (progn
   (if (= symb 1) (kreuzi (list xl yl 0)))
   (if (= symb 3) (kreuzii (list xl yl 0)))    
   )
  )
   (setq yl (+ yl dy))
 )
 ;y fallend rastern
 (setq yl (- (cadr sp) dy))
 (while (> yl (+ (cadr su) kgr))
  (if (< yl (- (cadr so) kgr))
   (progn
   (if (= symb 1) (kreuzi (list xl yl 0)))
   (if (= symb 3) (kreuzii (list xl yl 0)))     
   )
  ) 
   (setq yl (- yl dy))
 )

 (setq xl (- xl dx))
)
;y-Anri steigend*************************************************
(setq yl (cadr sp))
(while (< yl (- (cadr po) kgr))
 ;sl bilden
 (if (< yl (cadr pl)) (progn
                      (setq sl (inters pl pu (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (sin (angle pl pu))))))
                     (progn                     
                      (setq sl (inters po pl (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (sin (angle pl po)))))))
 ;sr bilden
 (if (< yl (cadr pr)) (progn
                      (setq sr (inters pu pr (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (sin (angle pu pr))))))
                     (progn                     
                      (setq sr (inters pr po (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (sin (angle pr po)))))))
 
 ;durchgezogenes Gitter?
 (command "layer" "se" "GITTERKREUZE" "")
 (if (= symb 2) (command "plinie" sl sr ""))
 ;Anri?
 (if (= anr 1) 
  (progn
   (command "layer" "se" "ANRISS" "")
   (command "plinie" sl (list (+ (car sl) lapo) (cadr sl)) "")
   (command "plinie" sr (list (- (car sr) lapu) (cadr sr)) "")))
 ;Text antragen X
  (command "layer" "se" "KOORDINATEN" "")
  (setq te bhw)
  (setq te (strcat te (rtos yl 2 andd)))
 (if (= to 1)
  (progn 
  (if (= tox 0)
  (progn
   (command "text" "p" "mr" (list (- (car sl) lapo) (cadr sl)) th 0 te)
   (command "text" "p" "ml" (list (+ (car sr) lapu) (cadr sr)) th 0 te)
  )
  (progn
   (command "text" "p" "ml" (list (- (car sl) lapo) (cadr sl)) th 180 te)
   (command "text" "p" "mr" (list (+ (car sr) lapu) (cadr sr)) th 180 te)
  ))
  )
;oder innen beschriften
  (progn 
  (if (= tox 0)
  (progn
   (command "text" "p" "ml" (list (+ (car sl) (* 2 lapo)) (cadr sl)) th 0 te)
   (command "text" "p" "mr" (list (- (car sr) (* 2 lapu)) (cadr sr)) th 0 te)
  )
  (progn
   (command "text" "p" "mr" (list (+ (car sl) (* 2 lapo)) (cadr sl)) th 180 te)
   (command "text" "p" "ml" (list (- (car sr) (* 2 lapu)) (cadr sr)) th 180 te)
  ))
  )
  )
(setq yl (+ yl dy))
)
;y-Anri fallend
(setq yl (- (cadr sp) dy))
(while (> yl (+ (cadr pu) kgr))
 ;sl bilden
 (if (< yl (cadr pl)) (progn
                      (setq sl (inters pl pu (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (sin (angle pl pu))))))
                     (progn                     
                      (setq sl (inters po pl (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapo (abs (/ (* 2 kgr) (sin (angle pl po)))))))
 ;sr bilden
 (if (< yl (cadr pr)) (progn
                      (setq sr (inters pu pr (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (sin (angle pu pr))))))
                     (progn                     
                      (setq sr (inters pr po (list 0 yl 0) (list 1 yl 0) nil))
                      (setq lapu (abs (/ (* 2 kgr) (sin (angle pr po)))))))
 
 ;durchgezogenes Gitter?
 (command "layer" "se" "GITTERKREUZE" "")
 (if (= symb 2) (command "plinie" sl sr ""))
 ;Anri?
 (if (= anr 1) 
  (progn
   (command "layer" "se" "ANRISS" "")
   (command "plinie" sl (list (+ (car sl) lapo) (cadr sl)) "")
   (command "plinie" sr (list (- (car sr) lapu) (cadr sr)) "")))
 ;Text antragen X
 (command "layer" "se" "KOORDINATEN" "")
 (setq te bhw)
 (setq te (strcat te (rtos yl 2 andd)))
 (if (= to 1)
  (progn
  (if (= tox 0)
  (progn
   (command "text" "p" "mr" (list (- (car sl) lapo) (cadr sl)) th 0 te)
   (command "text" "p" "ml" (list (+ (car sr) lapu) (cadr sr)) th 0 te)
  )
  (progn
   (command "text" "p" "ml" (list (- (car sl) lapo) (cadr sl)) th 180 te)
   (command "text" "p" "mr" (list (+ (car sr) lapu) (cadr sr)) th 180 te)
  ))
  )
;oder innen beschriften
  (progn
  (if (= tox 0)
  (progn
   (command "text" "p" "ml" (list (+ (car sl) (* 2 lapo)) (cadr sl)) th 0 te)
   (command "text" "p" "mr" (list (- (car sr) (* 2 lapu)) (cadr sr)) th 0 te)
  )
  (progn
   (command "text" "p" "mr" (list (+ (car sl) (* 2 lapo)) (cadr sl)) th 180 te)
   (command "text" "p" "ml" (list (- (car sr) (* 2 lapu)) (cadr sr)) th 180 te)
  ))
  )
  )
(setq yl (- yl dy))
)
;zu guter Letzt noch die Eckpktbeschriftung
(command "layer" "se" "ECKKOO" "")
(if (= epb 1)
 (progn
 ;Texte zusammenbauen
  (setq bex (strcat brw (rtos (car p1) 2 andd))) 
  (setq bey (strcat bhw (rtos (cadr p1) 2 andd)))
  (if (= swap 1) (setq bsw bex
                       bex bey
                       bey bsw))
 ;fr p1
  (setq w1 (angle p1 p2))
  (setq tp (polar p1 (- w1 pi) (* 2 kgr)))
  (command "text" "p" "ur" tp th (* (/ w1 pi) 180) bey)
  (setq tp (polar p1 (+ w1 (/ pi 2)) (* 2 kgr)))       
  (command "text" "p" "ul" tp th (+ (* (/ w1 pi) 180) 90) bex)
 ;Texte zusammenbauen
  (setq bex (strcat brw (rtos (car p4) 2 andd))) 
  (setq bey (strcat bhw (rtos (cadr p4) 2 andd)))
  (if (= swap 1) (setq bsw bex
                       bex bey
                       bey bsw))

  ;fr p4
  (setq w1 (angle p4 p3))
  (setq tp (polar p4 (- w1 pi) (* 2 kgr)))
  (command "text" "p" "ur" tp th (* (/ w1 pi) 180) bey)
  (setq tp (polar p4 (- w1 (/ pi 2)) (* 2 kgr)))       
  (command "text" "p" "ur" tp th (+ (* (/ w1 pi) 180) 90) bex)
 ;Text zusammenbauen
  (setq bex (strcat brw (rtos (car p2) 2 andd))) 
  (setq bey (strcat bhw (rtos (cadr p2) 2 andd)))
  (if (= swap 1) (setq bsw bex
                       bex bey
                       bey bsw))

  ;fr p2
  (setq w1 (angle p1 p2))
  (setq tp (polar p2 w1 (* 2 kgr)))
  (command "text" "p" "ul" tp th (* (/ w1 pi) 180) bey)
  (setq tp (polar p2 (+ w1 (/ pi 2)) (* 2 kgr)))       
  (command "text" "p" "ul" tp th (+ (* (/ w1 pi) 180) 90) bex)
 ;Text zusammenbauen
  (setq bex (strcat brw (rtos (car p3) 2 andd))) 
  (setq bey (strcat bhw (rtos (cadr p3) 2 andd)))
  (if (= swap 1) (setq bsw bex
                       bex bey
                       bey bsw))

  ;fr p3
  (setq w1 (angle p4 p3))
  (setq tp (polar p3 w1 (* 2 kgr)))
  (command "text" "p" "ul" tp th (* (/ w1 pi) 180) bey)
  (setq tp (polar p3 (- w1 (/ pi 2)) (* 2 kgr)))       
  (command "text" "p" "ur" tp th (+ (* (/ w1 pi) 180) 90) bex)

 )
)
;Reinitialisierung
(setvar "osmode" ofalt)
(command "layer" "se" aklayer "")
(setvar "aunits" setw1)
(setvar "angbase" setw2)
(setvar "angdir" setw3)
(unload_dialog dcl_id)
(setvar "cmdecho" 1)
)
;Funktion zum Zeichnen von normalen Kreuzen
(defun kreuzi(p)
;vorlufig feste gre...
(command "plinie" p (list (car p) (+ (cadr p) kgr) 0) "")
(command "plinie" p (list (car p) (- (cadr p) kgr) 0) "")
(command "plinie" p (list (+ (car p) kgr) (cadr p) 0) "")
(command "plinie" p (list (- (car p) kgr) (cadr p) 0) "")
)
;Funktion zum Zeichnen von Strichpkt-Kreuzen
(defun kreuzii(p)
;vorlufig feste gre...
(command "plinie" (list ( car p) (+ (cadr p) (/ kgr 2)) 0) (list (car p) (+ (cadr p) kgr) 0) "")
(command "plinie" (list ( car p) (- (cadr p) (/ kgr 2)) 0) (list (car p) (- (cadr p) kgr) 0) "")
(command "plinie" (list (+ (car p) (/ kgr 2)) (cadr p) 0) (list (+ (car p) kgr) (cadr p) 0) "")
(command "plinie" (list (- (car p) (/ kgr 2)) (cadr p) 0) (list (- (car p) kgr) (cadr p) 0) "")
(command "kreis" p (/ kgr 100) "")
)

(princ)
(princ)
