;**************************************************************************
;Lispbestandteil fr STR Men
;zugehrige Dateien: a0q-1a4.dwg,a0q.dwg ... a4q.dwg
;                    a0h.dwg ... a4h.dwg
;
;Die Fkt RAHMEN fgt die Rahmen abhngig vom MST und den Zeichnungseinheiten
;in die Zeichnung ein.
;Die Fkt SFELD fgt das Schriftfeld abhngig vom Skalierungsfaktor sr ein.
;Die Fkt SFELD1 fgt das Schriftfeld ohnen nderungsteil ein
;Die Fkt NPFL fgt einen N-Pfeil abhngig von sr ein
;Die Fkt RAST rastert den Rahmen mit dx dy abstnden.
;Skal ermittelt sr neu
;
;globale Variable sr... Auslagerung nach userr1
;
;***************************************************************************
(defun c:rahmen(/ p1 blatt f mst inp ps out)
 (setvar "cmdecho" 0)
 (setq p1 (getpoint "Einfgepunkt (links unten):"))
 (if (not p1) (setq p1 (list 0 0 0)))
 (terpri)
 ;(initget 1 "a0q a1q a2q a3q a4q a0h a1h a2h a3h a4h")
 (setq blatt (getstring "Blattformat eingeben (a0q a1q...a0h...)"))
 (terpri)
 (if (= (getvar "userr1") 0.0) (C:SKAL))
 (setq sr (getvar "userr1"))
 (terpri)
 ;pfad zur Rahmendatei zusammenbauen
 (setq inp blatt)
 ;prplot Einstellung fr mst berechnen
 (setq ps (/ 1 sr))
 ;Rahmen einfgen
 (command "_insert" inp p1 sr sr 0)
 (setq out (strcat "Beim Plotten mu der Mastab mit " (rtos ps 2 2) "=1 angegeben werden"))
 (princ out)
 (setq out (strcat "\nSkalierungsfaktor: " (rtos sr 2 3)))
 (princ out)
 (terpri)
)
(defun c:skal(/ mst f)
 (terpri)
 (setq f (getint "eine Zeichnungseinheit hat ? mm:"))
 (terpri)
 (setq mst (getint "Mastab 1:"))
 (terpri)
 (setq sr (/ (float mst) (float f)))  
 (setvar "userr1" sr)
) 
(defun c:sfeld(/ p1)
 (setvar "cmdecho" 0)
 (setq sr (getvar "userr1"))
  (if (/= sr 0.0)
    (progn
     (setq p1 (getpoint "rechte untere Ecke:"))
     (terpri)
     (command "_insert" "sblock" p1 sr sr 0)
    )
    (progn
     (C:SKAL)
     (setq sr (getvar "userr1"))
     (terpri)
     (setq p1 (getpoint "rechte untere Ecke:"))
     (terpri)
     (command "_insert" "sblock" p1 sr sr 0)
    )
  )
)
(defun c:sfeld1(/ p1)
 (setvar "cmdecho" 0)
 (setq sr (getvar "userr1"))
  (if (/= sr 0.0)
    (progn
     (setq p1 (getpoint "rechte untere Ecke:"))
     (terpri)
     (command "_insert" "sblock1" p1 sr sr 0)
    )
    (progn
     (C:SKAL)
     (setq sr (getvar "userr1"))
     (terpri)
     (setq p1 (getpoint "rechte untere Ecke:"))
     (terpri)
     (command "_insert" "sblock1" p1 sr sr 0)
    )
  )
)
(defun c:npfl(/ p1 arc)
 (setvar "cmdecho" 0)
 (if (= (getvar "userr1") 0.0) (C:SKAL))
 (setq sr (getvar "userr1"))
  (if sr
    (progn
     (setq p1 (getpoint "Einfgepunkt:"))
     (terpri)
     (setq arc (* 180 (/ (getangle "Ausrichtung:" p1) pi)))
     (terpri)
     (command "_insert" "npfeil" p1 sr sr arc)
    )
    (progn
     (setq sr (getreal "Skalierungsfaktor: "))
     (terpri)
     (setq p1 (getpoint "Einfgepunkt:"))
     (terpri)
     (setq arc (* 180 (/ (getangle "Ausrichtung:" p1) pi))) 
     (command "_insert" "npfeil" p1 sr sr arc)
    )
  )
)

(defun c:rasto(/ h p1 p2 dx dy x y p3 p4 p5 tyu tyo txl txr flx flx1 xmax out 
                ofalt)
 (setvar "cmdecho" 0)
 (if (= (getvar "userr1") 0.0) (C:SKAL))
 (setq sr (getvar "userr1"))
 (setq h (getvar "textsize"))
 (setq p1 (getpoint "\nlinke untere Ecke: "))
 (setq p2 (getpoint "\nobere rechte Ecke: "))
;ofang speichern dann aus
 (setq ofalt (getvar "osmode"))
 (setvar "osmode" 0)
 (setq dx (getreal "\ndx: "))
 (setq dy (getreal "\ndy: "))
 (if (not sr)
  (setq sr (getreal "\nSkalierungsfaktor: "))
 )
 (terpri)
;inneren Rahmen ausrechnen 
 (setq x (+ (* sr 10) (car p1)))
 (setq y (+ (* sr 10) (cadr p1)))
 (setq p3 (list x y 0))
 (setq x (- (car p2) (* sr 10)))
 (setq y (- (cadr p2)(* sr 10)))
 (setq p4 (list x y 0))
;linke obere Ecke vom Schriftfeld bestimmen P5
 (setq x (- (car p4) (* sr 130)))
 (setq y (+ (cadr p3) (* sr 180)))
 (setq p5 (list x y 0))
;Textorientierungen berechnen
 (setq tyu (+ (* sr 5) (cadr p1)))
 (setq tyo (- (cadr p2) (* sr 5)))
 (setq txl (+ (* sr 5) (car p1)))
 (setq txr (- (car p2) (* sr 5)))
;erstes Y bestimmen
 (setq y (+ (cadr p3) dy))
;nur einmal x-Koordinaten...
 (setq flx 1
       flx1 1)
 (while (< y (- (cadr p4) (/ dy 2)))
  (setq x (+ dx (car p3)))
  (if (< y (cadr p5))
   (setq xmax (- (car p5) (/ dx 2)))
   (setq xmax (- (car p4) (/ dx 2)))
  )
  (setq out (rtos (- y (cadr p3)) 2 2))
  (command "text" "p" "mz" (list txl y 0) h 90 out)
  (command "text" "p" "mz" (list txr y 0) h 90 out)
  (while (< x xmax)
;Kreuz malen
   (command "linie" (list x y 0) (list (+ x h) y 0)"")
   (command "linie" (list x y 0) (list (- x h) y 0)"")      
   (command "linie" (list x y 0) (list x (+ y h) 0)"")   
   (command "linie" (list x y 0) (list x (- y h) 0)"")   
;Text in rahmen einfgen
   (if (and (= xmax (- (car p4) (/ dx 2))) flx1)
   (progn
    (setq out (rtos (- x (car p3)) 2 2))
    (command "text" "p" "mz" (list x tyu 0) h 0 out)
    (command "text" "P" "mz" (list x tyo 0) h 0 out)
    (setq flx nil)
   ))
   (setq x (+ dx x))
  )
 (if (not flx) (setq flx1 nil))
 (setq y (+ dy y))
 )
 (command "linie" p3 (list (car p4) (cadr p3)) p4 (list (car p3) (cadr p4)) "s")
;rcksetzen
 (setvar "osmode" ofalt)
 (setvar "cmdecho" 1)
)
(defun c:katas(/ p1 y0 ys1 y2 y3 ex ey n x1 x2 x3 x4 x5)
 (if (= (getvar "userr1") 0.0) (C:SKAL))
 (setq sr (getvar "userr1"))
 (if sr 
 (progn
 (setq n (getint "Anzahl der Zeilen:"))
 (terpri)
 (setq p1 (getpoint "linke untere Rahmenecke:"))
 (terpri)
 (setq  ex (- (car p1) (* sr 5))
        ey (+ (cadr p1) (* sr 5))
        y0 (+ ey (* sr 288) (* n (* sr 7)))                 
        y1 (+ ey (* sr 125))
        x1 (- ex (* sr 184))
        )
 (command "_insert" "lblocku" p1 sr sr 0)       
 (command "_insert" "lblocko" (list ex y0) sr sr 0)      
;Rahmen vervollstndigen
 (command "plinie" (list ex y1) (list ex y0) (list x1 y0) (list x1 y1) "")
;Tabelle aufbauen
 (setq  y1 (+ ey (* sr 188) (* n (* sr 7)))
        y2 (- y1 (* sr 7))
        y3 (- y2 (* sr 8))
        x5 (- ex (* sr 16))
        x4 (- x5 (* sr 102))
        x3 (- x5 (* sr 124))
        x2 (- x5 (* sr 141))
        x1 (- x5 (* sr 160))
        )
 (command "plinie" (list x1 y1) (list x5 y1) "")
 (command "plinie" (list x1 y2) (list x5 y2) "")
 (command "plinie" (list x1 y3) (list x5 y3) "")
  (while (> n 0)
   (setq y3 (- y3 (* sr 7)))
   (command "plinie" (list x1 y3) (list x5 y3) "")
   (setq n (- n 1))
  )
 (command "plinie" (list x1 y1) (list x1 y3) "")
 (command "plinie" (list x5 y1) (list x5 y3) "")
 (command "plinie" (list x2 y2) (list x2 y3) "")
 (command "plinie" (list x3 y2) (list x3 y3) "")
 (command "plinie" (list x4 y2) (list x4 y3) "")

 )
 (princ "\nBitte erst skalieren!\n")
)
) 
;******************************************************************** 
;
;
;
;
;
;
;
;******************************************************************** 
(defun c:setmst()
(if (/= (getvar "userr1") 0.0)
 (alert "MST schon gestzt! Ggf. abbrechen.")
)
(c:skal)
;Bemaungsstil fr Bemaungen mit 0.25 Texthhe
(setvar "textsize" (* 2.5 (getvar "userr1")))
(c:bemset)
(command "layer" "n" "bem25" "fa" "rot" "bem25" "")
(command "bem" "sichern" "bem25" "exit")
;Bemaungsstil fr Bemaungen mit 0.35 Texthhe
(setvar "textsize" (* 3.5 (getvar "userr1")))
(c:bemset)
(command "layer" "n" "bem35" "fa" "gelb" "bem35" "")
(command "bem" "sichern" "bem35" "exit")
;Rahmen einfgen
(c:rahmen)
(command "zoom" "g")
)




(defun *error* (st)
 (princ "Abbruch...")
 (terpri)
)
(princ "\nRahmen einfgen mit RAHMEN")
(princ "\nSchriftfeld einfgen mit SFELD")
(princ "\nRastern mit RAST")
(prin1)
